// ADD.CPP - Implementation file for your Internet Server
//    add Extension

#include "stdafx.h"
#include "add.h"

#include <stdio.h>

///////////////////////////////////////////////////////////////////////
// command-parsing map

BEGIN_PARSE_MAP(CAddExtension, CHttpServer)
	// TODO: insert your ON_PARSE_COMMAND() and 
	// ON_PARSE_COMMAND_PARAMS() here to hook up your commands.
	// For example:

	ON_PARSE_COMMAND(Default, CAddExtension, ITS_PSTR ITS_PSTR)
	ON_PARSE_COMMAND_PARAMS("opone=~ optwo=~")
	DEFAULT_PARSE_COMMAND(Default, CAddExtension)
END_PARSE_MAP(CAddExtension)


///////////////////////////////////////////////////////////////////////
// The one and only CAddExtension object

CAddExtension theExtension;


///////////////////////////////////////////////////////////////////////
// CAddExtension implementation

CAddExtension::CAddExtension()
{
}

CAddExtension::~CAddExtension()
{
}

BOOL CAddExtension::GetExtensionVersion(HSE_VERSION_INFO* pVer)
{
	// Call default implementation for initialization
	CHttpServer::GetExtensionVersion(pVer);

	// Load description string
	TCHAR sz[HSE_MAX_EXT_DLL_NAME_LEN+1];
	ISAPIVERIFY(::LoadString(AfxGetResourceHandle(),
			IDS_SERVER, sz, HSE_MAX_EXT_DLL_NAME_LEN));
	_tcscpy(pVer->lpszExtensionDesc, sz);
	return TRUE;
}

///////////////////////////////////////////////////////////////////////
// CAddExtension command handlers

void CAddExtension::Default(CHttpServerContext* pCtxt,
							LPCTSTR pstrOp1, LPCTSTR pstrOp2)
{
	StartContent(pCtxt);
	WriteTitle(pCtxt);

	int nOp1;
	int nOp2;

	if (*pstrOp1 != '~' && *pstrOp2 != '~')
	{
		nOp1 = atoi(pstrOp1);
		nOp2 = atoi(pstrOp2);

		char sz[1024];

		sprintf(sz, "The result is: %d\n", nOp1 + nOp2);
		*pCtxt << sz;
	}
	else
	{
	*pCtxt << "<FORM ACTION=\"http://mooseboy/add.dll\" METHOD=\"GET\">";
    *pCtxt << "Enter the first number: <INPUT TYPE=\"text\" NAME=\"opone\" VALUE=\"0\" SIZE=10><p>";
    *pCtxt << "Enter the second number: <INPUT TYPE=\"text\" NAME=\"optwo\" VALUE=\"0\" SIZE=10><p>";
    *pCtxt << "<p> <INPUT TYPE = \"SUBMIT\" VALUE=\"Add it up\">";
    *pCtxt << "</FORM>";
	}

	EndContent(pCtxt);
}

// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CAddExtension, CHttpServer)
	//{{AFX_MSG_MAP(CAddExtension)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0



///////////////////////////////////////////////////////////////////////
// If your extension will not use MFC, you'll need this code to make
// sure the extension objects can find the resource handle for the
// module.  If you convert your extension to not be dependent on MFC,
// remove the comments arounn the following AfxGetResourceHandle()
// and DllMain() functions, as well as the g_hInstance global.

static HINSTANCE g_hInstance;

HINSTANCE AFXISAPI AfxGetResourceHandle()
{
	return g_hInstance;
}

BOOL WINAPI DllMain(HINSTANCE hInst, ULONG ulReason,
					LPVOID lpReserved)
{
	if (ulReason == DLL_PROCESS_ATTACH)
	{
		g_hInstance = hInst;
	}

	return TRUE;
}
